
SuperStrict

Type TTile

	Global _width:Int	= 32		'breite der Tiles
	Global _height:Int= 16		'hhe der Tiles

	Field _xPos:Int			'x-position
	Field _yPos:Int			'y-position
	Field _zPos:Int			'z-position (hhe)
	
	Field _material:Int		'material (frame nummer)
	
	'seter
	
	Method setXPos( xPos:Int )
	
		_xPos = xPos
	
	EndMethod
	
	Method setYPos( yPos:Int )
	
		_yPos = yPos
	
	EndMethod
	
	Method setZPos( zPos:Int )
	
		_zPos = zPos
	
	EndMethod
	
	Method setMaterial( material:Int )
	
		_material = material
	
	EndMethod
	
	'geter
	
	Method getXPos:Int()
	
		Return _xPos
	
	EndMethod
	
	Method getYPos:Int()
	
		Return _yPos
	
	EndMethod
	
	Method getZPos:Int()
	
		Return _zPos
	
	EndMethod
	
	Method getMaterial:Int()
	
		Return _material
	
	EndMethod
	
	'functions / methods
	
	Function Create:TTile( xPos:Int,yPos:Int,zPos:Int,material:Int )
	
		Local n:TTile = New TTile		'neues TTile objekt erstellen
		
			n.setXPos( xPos )			'x-position bergeben
			n.setYPos( yPos-zPos )		'y-position bergeben (-hhe)
			n.setMaterial( material )	'material-nummer bergeben
		
		Return n						'fertiges TTile zurckgeben
	
	EndFunction
	
	Method draw()
	
		DrawImage tileset,_xPos,_yPos - _zPos,_material
	
	EndMethod

EndType

Global map:TTile [ 256,256 ]		'map Array zum speichern aller TTile-objekte

Graphics 800,600,32

SeedRnd( MilliSecs() )

Global tileset:TImage = LoadAnimImage( "gfx/tileset.png",32,64,0,2 )		'tileset laden	

readMap()		'das Array 'Map' mit TTiles fllen
		
'MAINLOOP
		
Repeat
Cls

	drawMap()		'Map neu Zeichnen

Flip 0
Until AppTerminate() Or KeyDown( key_escape )

Function readMap()
	
	For Local y:Int = 0 To 255
		For Local x:Int = 0 To 255
		
			Local xpos:Int = ((x*TTile._width)+(y Mod 2)*(TTile._width/2))	'x-position berechnen
			Local ypos:Int = (y*(TTile._height/2))						'y-position berechnen
			
			map[ x,y ] = TTile.Create( xPos,yPos,Rand( -10,10 ),0 )					'neues TTile erstellen mit x,y,z,m parametern
			
		Next
	Next

EndFunction

Function drawMap()

	For Local y:Int = 0 To 255
		For Local x:Int = 0 To 255
		
			map[ x,y ].draw()		'TTile.Draw() Methode des jeweiligen Tiles aufrufen
			
		Next
	Next

EndFunction
